Scala Standard Library2.13.0 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package concurrent

  This package object contains primitives for concurrent and parallel programming.

  This package object contains primitives for concurrent and parallel programming.

  #### Guide

  A more detailed guide to Futures and Promises, including discussion and examples can be found at http://docs.scala-lang.org/overviews/core/futures.html.

  #### Common Imports

  When working with Futures, you will often find that importing the whole concurrent package is convenient:

      import scala.concurrent._

  When using things like `Future`s, it is often required to have an implicit `ExecutionContext` in scope. The general advice for these implicits are as follows.

  If the code in question is a class or method definition, and no `ExecutionContext` is available, request one from the caller by adding an implicit parameter list:

      def myMethod(myParam: MyType)(implicit ec: ExecutionContext) = …
      //Or
      class MyClass(myParam: MyType)(implicit ec: ExecutionContext) { … }

  This allows the caller of the method, or creator of the instance of the class, to decide which `ExecutionContext` should be used.

  For typical REPL usage and experimentation, importing the global `ExecutionContext` is often desired.

      import scala.concurrent.ExcutionContext.Implicits.global

  #### Specifying Durations

  Operations often require a duration to be specified. A duration DSL is available to make defining these easier:

      import scala.concurrent.duration._
      val d: Duration = 10.seconds

  #### Using Futures For Non-blocking Computation

  Basic use of futures is easy with the factory method on Future, which executes a provided function asynchronously, handing you back a future result of that function without blocking the current thread. In order to create the Future you will need either an implicit or explicit ExecutionContext to be provided:

      import scala.concurrent._
      import ExecutionContext.Implicits.global  // implicit execution context

      val firstZebra: Future[Int] = Future {
        val source = scala.io.Source.fromFile("/etc/dictionaries-common/words")
        source.toSeq.indexOfSlice("zebra")
      }

  #### Avoid Blocking

  Although blocking is possible in order to await results (with a mandatory timeout duration):

      import scala.concurrent.duration._
      Await.result(firstZebra, 10.seconds)

  and although this is sometimes necessary to do, in particular for testing purposes, blocking in general is discouraged when working with Futures and concurrency in order to avoid potential deadlocks and improve performance. Instead, use callbacks or combinators to remain in the future domain:

      val animalRange: Future[Int] = for {
        aardvark <- firstAardvark
        zebra <- firstZebra
      } yield zebra - aardvark

      animalRange.onSuccess {
        case x if x > 500000 => println("It's a long way from Aardvark to Zebra")
      }

  Definition Classes
    scala
-  package duration
  Definition Classes
    concurrent
- Await
- Awaitable
- Batchable
- BlockContext
- CanAwait
- Channel
- DelayedLazyVal
- ExecutionContext
- ExecutionContextExecutor
- ExecutionContextExecutorService
- Future
- JavaConversions
- OnCompleteRunnable
- Promise
- SyncChannel
- SyncVar

o

scala.concurrent

# Future

###
Companion trait Future

#### object Future

Future companion object.

Source
  Future.scala

Linear Supertypes
AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Future
2. AnyRef
3. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
4.  final def apply[T](body: => T)(implicit executor: ExecutionContext): Future[T]

   Starts an asynchronous computation and returns a `Future` instance with the result of that computation.

   Starts an asynchronous computation and returns a `Future` instance with the result of that computation.

   The following expressions are equivalent:

       val f1 = Future(expr)
       val f2 = Future.unit.map(_ => expr)
       val f3 = Future.unit.transform(_ => Success(expr))

   The result becomes available once the asynchronous computation is completed.

   T

     the type of the result

   body

     the asynchronous computation

   executor

     the execution context on which the future is run

   returns

     the `Future` holding the result of the computation

5.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

6.  def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
   Note

     not specified by SLS as a member of AnyRef

7.  final def delegate[T](body: => Future[T])(implicit executor: ExecutionContext): Future[T]

   Starts an asynchronous computation and returns a `Future` instance with the result of that computation once it completes.

   Starts an asynchronous computation and returns a `Future` instance with the result of that computation once it completes.

   The following expressions are semantically equivalent:

       val f1 = Future(expr).flatten
       val f2 = Future.delegate(expr)
       val f3 = Future.unit.flatMap(_ => expr)

   The result becomes available once the resulting Future of the asynchronous computation is completed.

   T

     the type of the result

   body

     the asynchronous computation, returning a Future

   executor

     the execution context on which the `body` is evaluated in

   returns

     the `Future` holding the result of the computation

8.  final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`that`) is a reference to the receiver object (`this`).

   Tests whether the argument (`that`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef
9.  def equals(arg0: AnyRef): Boolean

   The equality method for reference types.

   The equality method for reference types. Default implementation delegates to `eq`.

   See also `equals` in scala.Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
10.  final def failed[T](exception: Throwable): Future[T]

    Creates an already completed Future with the specified exception.

    Creates an already completed Future with the specified exception.

    T

      the type of the value in the future

    exception

      the non-null instance of `Throwable`

    returns

      the newly created `Future` instance

11.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

12.  final def find[T](futures: collection.immutable.Iterable[Future[T]])(p: (T) => Boolean)(implicit executor: ExecutionContext): Future[Option[T]]

    Asynchronously and non-blockingly returns a `Future` that will hold the optional result of the first `Future` with a result that matches the predicate, failed `Future`s will be ignored.

    Asynchronously and non-blockingly returns a `Future` that will hold the optional result of the first `Future` with a result that matches the predicate, failed `Future`s will be ignored.

    T

      the type of the value in the future

    futures

      the `scala.collection.immutable.Iterable` of Futures to search

    p

      the predicate which indicates if it's a match

    returns

      the `Future` holding the optional result of the search

13.  final def firstCompletedOf[T](futures: IterableOnce[Future[T]])(implicit executor: ExecutionContext): Future[T]

    Asynchronously and non-blockingly returns a new `Future` to the result of the first future in the list that is completed.

    Asynchronously and non-blockingly returns a new `Future` to the result of the first future in the list that is completed. This means no matter if it is completed as a success or as a failure.

    T

      the type of the value in the future

    futures

      the `IterableOnce` of Futures in which to find the first completed

    returns

      the `Future` holding the result of the future that is first to be completed

14.  final def foldLeft[T, R](futures: collection.immutable.Iterable[Future[T]])(zero: R)(op: (R, T) => R)(implicit executor: ExecutionContext): Future[R]

    A non-blocking, asynchronous left fold over the specified futures, with the start value of the given zero.

    A non-blocking, asynchronous left fold over the specified futures, with the start value of the given zero. The fold is performed asynchronously in left-to-right order as the futures become completed. The result will be the first failure of any of the futures, or any failure in the actual fold, or the result of the fold.

    Example:

        val futureSum = Future.foldLeft(futures)(0)(_ + _)

    T

      the type of the value of the input Futures

    R

      the type of the value of the returned `Future`

    futures

      the `scala.collection.immutable.Iterable` of Futures to be folded

    zero

      the start value of the fold

    op

      the fold operation to be applied to the zero and futures

    returns

      the `Future` holding the result of the fold

15.  final def fromTry[T](result: Try[T]): Future[T]

    Creates an already completed Future with the specified result or exception.

    Creates an already completed Future with the specified result or exception.

    T

      the type of the value in the `Future`

    result

      the result of the returned `Future` instance

    returns

      the newly created `Future` instance

16.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
17.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
18.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
19.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
20.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

21.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

22.  final def reduceLeft[T, R >: T](futures: collection.immutable.Iterable[Future[T]])(op: (R, T) => R)(implicit executor: ExecutionContext): Future[R]

    Initiates a non-blocking, asynchronous, left reduction over the supplied futures where the zero is the result value of the first `Future`.

    Initiates a non-blocking, asynchronous, left reduction over the supplied futures where the zero is the result value of the first `Future`.

    Example:

        val futureSum = Future.reduceLeft(futures)(_ + _)

    T

      the type of the value of the input Futures

    R

      the type of the value of the returned `Future`

    futures

      the `scala.collection.immutable.Iterable` of Futures to be reduced

    op

      the reduce operation which is applied to the results of the futures

    returns

      the `Future` holding the result of the reduce

23.  final def sequence[A, CC[X] <: IterableOnce[X], To](in: CC[Future[A]])(implicit bf: BuildFrom[CC[Future[A]], A, To], executor: ExecutionContext): Future[To]

    Simple version of `Future.traverse`.

    Simple version of `Future.traverse`. Asynchronously and non-blockingly transforms, in essence, a `IterableOnce[Future[A]]` into a `Future[IterableOnce[A]]`. Useful for reducing many `Future`s into a single `Future`.

    A

      the type of the value inside the Futures

    CC

      the type of the `IterableOnce` of Futures

    To

      the type of the resulting collection

    in

      the `IterableOnce` of Futures which will be sequenced

    returns

      the `Future` of the resulting collection

24.  final def successful[T](result: T): Future[T]

    Creates an already completed Future with the specified result.

    Creates an already completed Future with the specified result.

    T

      the type of the value in the future

    result

      the given successful value

    returns

      the newly created `Future` instance

25.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
26.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
27.  final def traverse[A, B, M[X] <: IterableOnce[X]](in: M[A])(fn: (A) => Future[B])(implicit bf: BuildFrom[M[A], B, M[B]], executor: ExecutionContext): Future[M[B]]

    Asynchronously and non-blockingly transforms a `IterableOnce[A]` into a `Future[IterableOnce[B]]` using the provided function `A => Future[B]`.

    Asynchronously and non-blockingly transforms a `IterableOnce[A]` into a `Future[IterableOnce[B]]` using the provided function `A => Future[B]`. This is useful for performing a parallel map. For example, to apply a function to all items of a list in parallel:

        val myFutureList = Future.traverse(myList)(x => Future(myFunc(x)))

    A

      the type of the value inside the Futures in the collection

    B

      the type of the value of the returned `Future`

    M

      the type of the collection of Futures

    in

      the collection to be mapped over with the provided function to produce a collection of Futures that is then sequenced into a Future collection

    fn

      the function to be mapped over the collection to produce a collection of Futures

    returns

      the `Future` of the collection of results

28.  final val unit: Future[Unit]

    A Future which is completed with the Unit value.

29.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
30.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
31.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
32.  object never extends Future[Nothing]

    A Future which is never completed.

### Deprecated Value Members

1.  def fold[T, R](futures: IterableOnce[Future[T]])(zero: R)(op: (R, T) => R)(implicit executor: ExecutionContext): Future[R]

   A non-blocking, asynchronous fold over the specified futures, with the start value of the given zero.

   A non-blocking, asynchronous fold over the specified futures, with the start value of the given zero. The fold is performed on the thread where the last future is completed, the result will be the first failure of any of the futures, or any failure in the actual fold, or the result of the fold.

   Example:

       val futureSum = Future.fold(futures)(0)(_ + _)

   T

     the type of the value of the input Futures

   R

     the type of the value of the returned `Future`

   futures

     the `IterableOnce` of Futures to be folded

   zero

     the start value of the fold

   op

     the fold operation to be applied to the zero and futures

   returns

     the `Future` holding the result of the fold

   Annotations
     @deprecated
   Deprecated

     (Since version 2.12.0) use Future.foldLeft instead

2.  final def reduce[T, R >: T](futures: IterableOnce[Future[T]])(op: (R, T) => R)(implicit executor: ExecutionContext): Future[R]

   Initiates a non-blocking, asynchronous, fold over the supplied futures where the fold-zero is the result value of the first `Future` in the collection.

   Initiates a non-blocking, asynchronous, fold over the supplied futures where the fold-zero is the result value of the first `Future` in the collection.

   Example:

       val futureSum = Future.reduce(futures)(_ + _)

   T

     the type of the value of the input Futures

   R

     the type of the value of the returned `Future`

   futures

     the `IterableOnce` of Futures to be reduced

   op

     the reduce operation which is applied to the results of the futures

   returns

     the `Future` holding the result of the reduce

   Annotations
     @deprecated
   Deprecated

     (Since version 2.12.0) use Future.reduceLeft instead

### Inherited from AnyRef

### Inherited from Any

### Ungrouped